#ifndef CLAG_H
#define CLAG_H

#define CLAG_SINGLY_CONNECTED_PORT 65535

typedef enum
{
    CLAG_ROLE_NONE,
    CLAG_ROLE_MASTER,
    CLAG_ROLE_SLAVE
} clag_role_t;

typedef struct {
    char prt_name[IFNAMSIZ];
    __u8 dual_src_addr[ETH_ALEN];
    __u32 remote_port_id;
} clag_if_info_t;

extern hash_table_t *clag_if_ht;

bool inline clag_role_configured();
bool inline clag_role_master();
bool inline clag_role_slave();
bool inline clag_is_isl_port(port_t * prt);
port_t *clag_find_isl_br(bridge_t *br);
port_t *clag_find_isl();
bool clag_isl_up(bridge_t *br);
bool inline clag_is_dual_connected(port_t * prt);
void clag_set_isl(bool add, char *prt_name);
void clag_set_isl_state(bool add, char *isl_oper_up);
void clag_set_dual_src_addr(bool add, __u8 *dual_src_addr, char *prt_name,
                    __u32 remote_port_id);
void clag_set_role(bool add, char *role);
void clag_set_system_mac(bool add, __u8 *sys_mac);
int clag_client_init(void);
void clag_client_one_second(void);
void clag_set_sys_mac_br(bridge_t *br, __u8 *sys_mac);
void clag_client_cleanup(void);
int clag_request_dump(void);
void clag_config_to_vlan_bond(char *bond_dev, char *vlan_dev);
#endif /* CLAG_H */
